/*---------------------------------------------------------------------\
|                                                                      |
|                     _     _   _   _     __     _                     |
|                    | |   | | | \_/ |   /  \   | |                    |
|                    | |   | | | |_| |  / /\ \  | |                    |
|                    | |__ | | | | | | / ____ \ | |__                  |
|                    |____||_| |_| |_|/ /    \ \|____|                 |
|                                                                      |
|                             ca-mgm library                           |
|                                                                      |
|                                         (C) SUSE Linux Products GmbH |
\----------------------------------------------------------------------/

File:       Commands.hpp

Author:     Michael Calmer
Maintainer: Michael Calmer
/-*/

/**
* @file   Commands.hpp
* @brief  This file is private for the ca-mgm library.
*         It defines some commands with full path
*/
#ifndef   LIMAL_CA_MGM_COMMANDS_HPP
#define   LIMAL_CA_MGM_COMMANDS_HPP

#include <limal/config.h>
#include <blocxx/String.hpp>

namespace LIMAL_NAMESPACE {

namespace CA_MGM_NAMESPACE {

const blocxx::String OPENSSL_COMMAND  = "/usr/bin/openssl";
const blocxx::String C_REHASH_COMMAND = "/usr/bin/c_rehash";

}
}

#endif /* LIMAL_CA_MGM_COMMANDS_HPP */

